"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCallUsageArgsFromStatement = void 0;
const ts_morph_1 = require("ts-morph");
const call_1 = require("./call");
function getCallUsageArgsFromStatement(args) {
    const { source, filePath, chainCallFuncNames } = args;
    return getAllStatment(source).reduce((acc, cur) => {
        const result = (0, call_1.getArgsFromCall)({
            source: cur,
            filePath,
            chainCallFuncNames,
        });
        result && acc.push(result);
        return acc;
    }, []);
}
exports.getCallUsageArgsFromStatement = getCallUsageArgsFromStatement;
function getAllStatment(source) {
    return [
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.EmptyStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.VariableStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.ExpressionStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.IfStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.DoStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.WhileStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.ForStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.ForInStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.ForOfStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.ContinueStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.BreakStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.ReturnStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.WithStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.SwitchStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.LabeledStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.ThrowStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.TryStatement),
        ...source.getDescendantsOfKind(ts_morph_1.SyntaxKind.DebuggerStatement),
    ];
}
